"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AdharaListView = function (_AdharaView) {
    _inherits(AdharaListView, _AdharaView);

    function AdharaListView() {
        _classCallCheck(this, AdharaListView);

        return _possibleConstructorReturn(this, (AdharaListView.__proto__ || Object.getPrototypeOf(AdharaListView)).apply(this, arguments));
    }

    _createClass(AdharaListView, [{
        key: "fetchData",
        value: function fetchData() {
            this._state.fetching_data = true;
            this.render();
            _get(AdharaListView.prototype.__proto__ || Object.getPrototypeOf(AdharaListView.prototype), "fetchData", this).call(this);
        }
    }, {
        key: "template",
        get: function get() {
            return "adhara-list";
        }

        /**
         * @function
         * @getter
         * @returns {HandlebarTemplate} template of the list structure
         * */

    }, {
        key: "listTemplate",
        get: function get() {
            throw new Error("override `get listTemplate`");
        }

        /**
         * @function
         * @getter
         * @returns {HandlebarTemplate} template of the list header
         * */

    }, {
        key: "headerTemplate",
        get: function get() {
            throw new Error("override `get headerTemplate`");
        }

        /**
         * @method
         * @getter
         * @returns {HandlebarTemplate} template of a list item
         * */

    }, {
        key: "itemTemplate",
        get: function get() {
            throw new Error("override `get itemTemplate`");
        }

        /**
         * @method
         * @getter
         * @returns {String} Table title that is to be rendered
         * */

    }, {
        key: "title",
        get: function get() {
            return "";
        }

        /**
         * @method
         * @getter
         * @returns {Boolean} whether to enable pagination or not
         * */

    }, {
        key: "isPaginationRequired",
        get: function get() {
            return false;
        }

        /**
         * @typedef {Object} ColumnConfig
         * @property {String} key - column key
         * @property {String} name - column name that is to be rendered
         * @property {Boolean} trust_as_html - whether to render as text content or HTML content
         * @example
         * {
         *  key: "column_key",
         *  name: "Column Name",
         *  trust_as_html: false // whether to render HTML as buttons or not
         * }
         * */

        /**
         * @method
         * @getter
         * @returns {Array<ColumnConfig>} list of columns in the format of column configuration
         * */

    }, {
        key: "columns",
        get: function get() {
            return [];
        }
    }, {
        key: "noDataAvailable",
        get: function get() {
            return "No Data Available";
        }

        /**
         * @function
         * @getter
         * @returns {Boolean} whether add new button is required or not
         * */

    }, {
        key: "addNew",
        get: function get() {
            return false;
        }
    }]);

    return AdharaListView;
}(AdharaView);
//# sourceMappingURL=ListView.js.map